/*
 * Coscine Web API
 *
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Coscine.ApiClient.Core.Client.OpenAPIDateConverter;

namespace Coscine.ApiClient.Core.Model
{
    /// <summary>
    /// Represents the data transfer object (DTO) for RDS options.
    /// </summary>
    [DataContract(Name = "RdsOptionsDto")]
    public partial class RdsOptionsDto : IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="RdsOptionsDto" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected RdsOptionsDto() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="RdsOptionsDto" /> class.
        /// </summary>
        /// <param name="bucketName">The name of the bucket associated with RDS. (required).</param>
        /// <param name="size">size.</param>
        public RdsOptionsDto(string bucketName = default(string), QuotaDto size = default(QuotaDto))
        {
            // to ensure "bucketName" is required (not null)
            if (bucketName == null)
            {
                throw new ArgumentNullException("bucketName is a required property for RdsOptionsDto and cannot be null");
            }
            this.BucketName = bucketName;
            this.Size = size;
        }

        /// <summary>
        /// The name of the bucket associated with RDS.
        /// </summary>
        /// <value>The name of the bucket associated with RDS.</value>
        [DataMember(Name = "bucketName", IsRequired = true, EmitDefaultValue = true)]
        public string BucketName { get; set; }

        /// <summary>
        /// Gets or Sets Size
        /// </summary>
        [DataMember(Name = "size", EmitDefaultValue = false)]
        public QuotaDto Size { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class RdsOptionsDto {\n");
            sb.Append("  BucketName: ").Append(BucketName).Append("\n");
            sb.Append("  Size: ").Append(Size).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
